# Copyright 2011 Tony Young
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# This is a class for representing colors.

define (require, exports, module) ->
    lang = require './../lang'

    # Colors are immutable types. Each component should be a floating-point
    # number in the range of 0.0 to 1.0.
    Color = (r, g, b, a) ->
        @r = r
        @g = g
        @b = b
        @a = a
        lang.freeze @
        return

    # Create a color from an array.
    Color.fromArray = (array) ->
        new Color array[0], array[1], array[2], array[3]

    # Some colors.
    Color.RED = new Color 1.0, 0.0, 0.0, 1.0
    Color.GREEN = new Color 0.0, 1.0, 0.0, 1.0
    Color.BLUE = new Color 0.0, 0.0, 1.0, 1.0
    Color.TRANSPARENT = new Color 0.0, 0.0, 0.0, 0.0
    Color.BLACK = new Color 0.0, 0.0, 0.0, 1.0
    Color.WHITE = new Color 1.0, 1.0, 1.0, 1.0

    module.exports = Color

