# Copyright 2011 Tony Young
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# This contains various types which will be polyfilled.

define (require, exports, module) ->
    # This provides a polyfill for typed arrays.
    _TypedArrayPolyfill = (data) ->
        if typeof data == 'number'
            Array data
        else
            data.slice()

    _Int8Array = if Int8Array? then Int8Array else _TypedArrayPolyfill
    _Int16Array = if Int16Array? then Int16Array else _TypedArrayPolyfill
    _Int32Array = if Int32Array? then Int32Array else _TypedArrayPolyfill
    _Float32Array = if Float32Array? then Float32Array else _TypedArrayPolyfill

    module.exports =
        Int8Array       : _Int8Array
        Int16Array      : _Int16Array
        Int32Array      : _Int32Array
        Float32Array    : _Float32Array
